=== modified file 'bzrlib/sign_my_commits.py'
--- bzrlib/sign_my_commits.py	2007-07-10 10:33:45 +0000
+++ bzrlib/sign_my_commits.py	2007-11-22 02:23:57 +0000
@@ -65,18 +65,25 @@
         count = 0
         repo.lock_write()
         try:
-            for rev_id in repo.get_ancestry(branch.last_revision())[1:]:
-                if repo.has_signature_for_revision_id(rev_id):
-                    continue
-                rev = repo.get_revision(rev_id)
-                if rev.committer != committer:
-                    continue
-                # We have a revision without a signature who has a 
-                # matching committer, start signing
-                print rev_id
-                count += 1
-                if not dry_run:
-                    repo.sign_revision(rev_id, gpg_strategy)
+            repo.start_write_group()
+            try:
+                for rev_id in repo.get_ancestry(branch.last_revision())[1:]:
+                    if repo.has_signature_for_revision_id(rev_id):
+                        continue
+                    rev = repo.get_revision(rev_id)
+                    if rev.committer != committer:
+                        continue
+                    # We have a revision without a signature who has a 
+                    # matching committer, start signing
+                    print rev_id
+                    count += 1
+                    if not dry_run:
+                        repo.sign_revision(rev_id, gpg_strategy)
+            except:
+                repo.abort_write_group()
+                raise
+            else:
+                repo.commit_write_group()
         finally:
             repo.unlock()
         print 'Signed %d revisions' % (count,)

